#!/bin/probevue

/* Problem: 


*/

unsigned long vuetrace_int(int i);
unsigned long vuetrace_lptr(long *p);
unsigned long vuetrace_long(long l);
unsigned long vuetrace_ulong(unsigned long ul);
unsigned long vuetrace_longlong(long long ll);

unsigned long gul;
unsigned int gui;
long gl;

@@BEGIN
{      
   printf("@@BEGIN {\n");                                    /* 32  64  act */
   printf("   unsigned long = %d\n", sizeof(unsigned long)); /* 4   8   4   */
   printf("   long = %d\n", sizeof(long));                   /* 4   8   4   */
   printf("   unsigned int = %d\n", sizeof(unsigned int));   /* 4   4   4   */
   printf("   global unsigned long = %d\n", sizeof(gul));    /* 8   8   4   */
   printf("   global long = %d\n", sizeof(gl));              /* 8   8   4   */
   printf("   global unsigned int = %d\n", sizeof(gui));     /* 4   4   4   */
   printf("}\n");                                            /* ^   ^       */
                                                             /* |   |       */
                                                             /* See p26  EUG*/
}


@@uft:$__CPID:*:vuetrace_lptr:entry
{
   long *ptr;

   ptr = __arg1;

   printf("Pointer size = %lld\n", sizeof(ptr));
}


@@uft:$__CPID:*:vuetrace_long:entry
{
   long l;

   l = __arg1;

   printf("long size = %lld\n", sizeof(l));
   printf("long value = %lld\n", l);
}

@@uft:$__CPID:*:vuetrace_ulong:entry
{
   unsigned long ul;

   ul = __arg1;
   gul = __arg1;

   printf("unsigned long size = %lld\n", sizeof(ul));
   printf("unsigned long value = %llu\n", ul);
   trace(ul);

}

@@uft:$__CPID:*:vuetrace_int:entry
{
   int i;

   i = __arg1;

   printf("int size = %lld\n", sizeof(i));
}

@@uft:$__CPID:*:vuetrace_longlong:entry
{
   long long ll;

   ll = __arg1;

   printf("long long size = %lld\n", sizeof(ll));
}


@@syscall:$__CPID:exit:entry
{
   exit();
}

